Blame


1 0efd7c9a 2022-07-30 op #! /bin/sh
2 0efd7c9a 2022-07-30 op #
3 0efd7c9a 2022-07-30 op # Copyright (c) 2014, 2015, 2016 Ingo Schwarze <schwarze@openbsd.org>
4 0efd7c9a 2022-07-30 op # Copyright (c) 2017, 2018 Kristaps Dzonsons <kristaps@bsd.lv>
5 0efd7c9a 2022-07-30 op # Copyright (c) 2022 Omar Polo <op@omarpolo.com>
6 0efd7c9a 2022-07-30 op #
7 0efd7c9a 2022-07-30 op # Permission to use, copy, modify, and distribute this software for any
8 0efd7c9a 2022-07-30 op # purpose with or without fee is hereby granted, provided that the above
9 0efd7c9a 2022-07-30 op # copyright notice and this permission notice appear in all copies.
10 0efd7c9a 2022-07-30 op #
11 0efd7c9a 2022-07-30 op # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12 0efd7c9a 2022-07-30 op # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13 0efd7c9a 2022-07-30 op # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14 0efd7c9a 2022-07-30 op # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15 0efd7c9a 2022-07-30 op # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16 0efd7c9a 2022-07-30 op # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17 0efd7c9a 2022-07-30 op # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
18 0efd7c9a 2022-07-30 op
19 0efd7c9a 2022-07-30 op OCONFIGURE_VERSION="0.3.8"
20 0efd7c9a 2022-07-30 op
21 0efd7c9a 2022-07-30 op #
22 0efd7c9a 2022-07-30 op # This script outputs two files: config.h and Makefile.configure.
23 0efd7c9a 2022-07-30 op # It tries to read from configure.local, which contains predefined
24 0efd7c9a 2022-07-30 op # values we won't autoconfigure.
25 0efd7c9a 2022-07-30 op #
26 0efd7c9a 2022-07-30 op # If you want to use configure with your project, have your GNUmakefile
27 0efd7c9a 2022-07-30 op # or BSDmakefile---whichever---try to import/include Makefile.configure
28 0efd7c9a 2022-07-30 op # at the beginning of the file.
29 0efd7c9a 2022-07-30 op #
30 0efd7c9a 2022-07-30 op # Like so (note no quotes, no period, etc.):
31 0efd7c9a 2022-07-30 op #
32 0efd7c9a 2022-07-30 op # include Makefile.configure
33 0efd7c9a 2022-07-30 op #
34 0efd7c9a 2022-07-30 op # If it exists, configure was run; otherwise, it wasn't.
35 0efd7c9a 2022-07-30 op #
36 0efd7c9a 2022-07-30 op # You'll probably want to change parts of this file. I've noted the
37 0efd7c9a 2022-07-30 op # parts that you'll probably change in the section documentation.
38 0efd7c9a 2022-07-30 op #
39 0efd7c9a 2022-07-30 op # See https://github.com/kristapsdz/oconfigure for more.
40 0efd7c9a 2022-07-30 op
41 0efd7c9a 2022-07-30 op set -e
42 0efd7c9a 2022-07-30 op
43 0efd7c9a 2022-07-30 op # try to be helpful
44 0efd7c9a 2022-07-30 op case "$1" in
45 0efd7c9a 2022-07-30 op --help|-h)
46 0efd7c9a 2022-07-30 op cat <<EOF
47 0efd7c9a 2022-07-30 op \`configure' configures lstun to adapt to many kinds of systems.
48 0efd7c9a 2022-07-30 op
49 0efd7c9a 2022-07-30 op Usage: $0 [-h] [--prefix=path] [VAR=VALUE]...
50 0efd7c9a 2022-07-30 op
51 0efd7c9a 2022-07-30 op The options are as follows:
52 0efd7c9a 2022-07-30 op
53 0efd7c9a 2022-07-30 op -h, --help print this help message
54 0efd7c9a 2022-07-30 op
55 0efd7c9a 2022-07-30 op --prefix=path equivalent to specifying the PREFIX variable, supported
56 0efd7c9a 2022-07-30 op for compatibility with other common "configure" scripts.
57 0efd7c9a 2022-07-30 op
58 0efd7c9a 2022-07-30 op Variables available:
59 0efd7c9a 2022-07-30 op
60 0efd7c9a 2022-07-30 op LDADD generic linker flags
61 0efd7c9a 2022-07-30 op LDADD_LIBEVENT linker flags for libevent
62 0efd7c9a 2022-07-30 op LDADD_LIBEVENT2 linker flags for libevent2
63 0efd7c9a 2022-07-30 op LDADD_LIBSOCKET linker flags for libsocket
64 0efd7c9a 2022-07-30 op LDFLAGS extra linker flags
65 0efd7c9a 2022-07-30 op CPPFLAGS C preprocessors flags
66 0efd7c9a 2022-07-30 op DESTDIR destination directory
67 0efd7c9a 2022-07-30 op PREFIX where to install files
68 0efd7c9a 2022-07-30 op MANDIR where to install man pages (PREFIX/man)
69 0efd7c9a 2022-07-30 op LIBDIR where to install libraries (PREFIX/lib)
70 0efd7c9a 2022-07-30 op BINDIR where to install executables (PREFIX/bin)
71 0efd7c9a 2022-07-30 op SHAREDIR where to install misc files (PREFIX/share)
72 0efd7c9a 2022-07-30 op SBINDIR where to install system executables (PREFIX/sbin)
73 0efd7c9a 2022-07-30 op INCLUDEDIR where to install header files (PREFIX/include)
74 0efd7c9a 2022-07-30 op PKG_CONFIG path to the pkg-config program or empty to disable
75 0efd7c9a 2022-07-30 op
76 0efd7c9a 2022-07-30 op Additionally, the following environment variables are used if set:
77 0efd7c9a 2022-07-30 op
78 0efd7c9a 2022-07-30 op CC the C compiler to use (defaults to cc, clang or gcc)
79 0efd7c9a 2022-07-30 op CFLAGS generic C compiler flags
80 0efd7c9a 2022-07-30 op
81 0efd7c9a 2022-07-30 op EOF
82 0efd7c9a 2022-07-30 op exit 0 ;;
83 0efd7c9a 2022-07-30 op esac
84 0efd7c9a 2022-07-30 op
85 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
86 0efd7c9a 2022-07-30 op # Prepare for running: move aside previous configure runs.
87 0efd7c9a 2022-07-30 op # Output file descriptor usage:
88 0efd7c9a 2022-07-30 op # 1 (stdout): config.h or Makefile.configure
89 0efd7c9a 2022-07-30 op # 2 (stderr): original stderr, usually to the console
90 0efd7c9a 2022-07-30 op # 3: config.log
91 0efd7c9a 2022-07-30 op # You DO NOT want to change this.
92 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
93 0efd7c9a 2022-07-30 op
94 0efd7c9a 2022-07-30 op [ -w config.log ] && mv config.log config.log.old
95 0efd7c9a 2022-07-30 op [ -w config.h ] && mv config.h config.h.old
96 0efd7c9a 2022-07-30 op
97 0efd7c9a 2022-07-30 op exec 3> config.log
98 0efd7c9a 2022-07-30 op echo "config.log: writing..."
99 0efd7c9a 2022-07-30 op
100 0efd7c9a 2022-07-30 op # GNU submake prints different output if invoked recursively, which
101 0efd7c9a 2022-07-30 op # messes up CC and CFLAGS detection. Pass --no-print-directory if
102 0efd7c9a 2022-07-30 op # we have a MAKELEVEL (GNU and FreeBSD make) and the argument is
103 0efd7c9a 2022-07-30 op # allowed.
104 0efd7c9a 2022-07-30 op
105 0efd7c9a 2022-07-30 op MAKE_FLAGS=""
106 0efd7c9a 2022-07-30 op
107 0efd7c9a 2022-07-30 op if [ -n "${MAKELEVEL}" ]; then
108 0efd7c9a 2022-07-30 op if [ "${MAKELEVEL}" -gt 0 ] ; then
109 0efd7c9a 2022-07-30 op MAKE_FLAGS="--no-print-directory"
110 0efd7c9a 2022-07-30 op echo "all:" | make ${MAKE_FLAGS} -sf - 2>/dev/null || MAKE_FLAGS=""
111 0efd7c9a 2022-07-30 op fi
112 0efd7c9a 2022-07-30 op fi
113 0efd7c9a 2022-07-30 op
114 0efd7c9a 2022-07-30 op if [ -n "$MAKE_FLAGS" ]; then
115 0efd7c9a 2022-07-30 op echo "GNU submake detected: using --no-print-directory" 1>&2
116 0efd7c9a 2022-07-30 op echo "GNU submake detected: using --no-print-directory" 1>&3
117 0efd7c9a 2022-07-30 op fi
118 0efd7c9a 2022-07-30 op
119 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
120 0efd7c9a 2022-07-30 op # Initialize all variables here such that nothing can leak in from the
121 0efd7c9a 2022-07-30 op # environment except for CC and CFLAGS, which we might have passed in.
122 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
123 0efd7c9a 2022-07-30 op
124 0efd7c9a 2022-07-30 op CC=`printf "all:\\n\\t@echo \\\$(CC)\\n" | make ${MAKE_FLAGS} -sf -`
125 0efd7c9a 2022-07-30 op CFLAGS=`printf "all:\\n\\t@echo \\\$(CFLAGS)\\n" | make ${MAKE_FLAGS} -sf -`
126 0efd7c9a 2022-07-30 op CFLAGS="${CFLAGS} -g -W -Wall -Wmissing-prototypes -Wstrict-prototypes"
127 0efd7c9a 2022-07-30 op CFLAGS="${CFLAGS} -Wmissing-declarations -Wno-unused-parameter"
128 0efd7c9a 2022-07-30 op CFLAGS="${CFLAGS} -Wno-sign-compare"
129 0efd7c9a 2022-07-30 op LDADD=
130 0efd7c9a 2022-07-30 op LDADD_LIBEVENT=
131 0efd7c9a 2022-07-30 op LDADD_LIBEVENT2=
132 0efd7c9a 2022-07-30 op LDADD_LIB_SOCKET=
133 0efd7c9a 2022-07-30 op LDADD_STATIC=
134 0efd7c9a 2022-07-30 op CPPFLAGS=
135 0efd7c9a 2022-07-30 op LDFLAGS=
136 0efd7c9a 2022-07-30 op DESTDIR=
137 0efd7c9a 2022-07-30 op PREFIX="/usr/local"
138 0efd7c9a 2022-07-30 op BINDIR=
139 0efd7c9a 2022-07-30 op SBINDIR=
140 0efd7c9a 2022-07-30 op INCLUDEDIR=
141 0efd7c9a 2022-07-30 op LIBDIR=
142 0efd7c9a 2022-07-30 op MANDIR=
143 0efd7c9a 2022-07-30 op SHAREDIR=
144 0efd7c9a 2022-07-30 op INSTALL="install"
145 0efd7c9a 2022-07-30 op INSTALL_PROGRAM=
146 0efd7c9a 2022-07-30 op INSTALL_LIB=
147 0efd7c9a 2022-07-30 op INSTALL_MAN=
148 0efd7c9a 2022-07-30 op INSTALL_DATA=
149 0efd7c9a 2022-07-30 op PKG_CONFIG=
150 0efd7c9a 2022-07-30 op
151 0efd7c9a 2022-07-30 op # SunOS sets "cc", but this doesn't exist.
152 0efd7c9a 2022-07-30 op # It does have gcc, so try that instead.
153 0efd7c9a 2022-07-30 op # Prefer clang, though.
154 0efd7c9a 2022-07-30 op
155 0efd7c9a 2022-07-30 op command -v ${CC} 2>/dev/null 1>&2 || {
156 0efd7c9a 2022-07-30 op echo "${CC} not found: trying clang" 1>&2
157 0efd7c9a 2022-07-30 op echo "${CC} not found: trying clang" 1>&3
158 0efd7c9a 2022-07-30 op CC=clang
159 0efd7c9a 2022-07-30 op command -v ${CC} 2>/dev/null 1>&2 || {
160 0efd7c9a 2022-07-30 op echo "${CC} not found: trying gcc" 1>&2
161 0efd7c9a 2022-07-30 op echo "${CC} not found: trying gcc" 1>&3
162 0efd7c9a 2022-07-30 op CC=gcc
163 0efd7c9a 2022-07-30 op command -v ${CC} 2>/dev/null 1>&2 || {
164 0efd7c9a 2022-07-30 op echo "gcc not found: giving up" 1>&2
165 0efd7c9a 2022-07-30 op echo "gcc not found: giving up" 1>&3
166 0efd7c9a 2022-07-30 op exit 1
167 0efd7c9a 2022-07-30 op }
168 0efd7c9a 2022-07-30 op }
169 0efd7c9a 2022-07-30 op }
170 0efd7c9a 2022-07-30 op
171 0efd7c9a 2022-07-30 op command -v pkg-config 2>/dev/null 1>&2 && {
172 0efd7c9a 2022-07-30 op PKG_CONFIG=pkg-config
173 0efd7c9a 2022-07-30 op echo "pkg-config found" 1>&2
174 0efd7c9a 2022-07-30 op echo "pkg-config found" 1>&3
175 0efd7c9a 2022-07-30 op } || {
176 0efd7c9a 2022-07-30 op echo "pkg-config not found" 1>&2
177 0efd7c9a 2022-07-30 op echo "pkg-config not found" 1>&3
178 0efd7c9a 2022-07-30 op }
179 0efd7c9a 2022-07-30 op
180 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
181 0efd7c9a 2022-07-30 op # Allow certain variables to be overriden on the command line.
182 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
183 0efd7c9a 2022-07-30 op
184 0efd7c9a 2022-07-30 op while [ $# -gt 0 ]; do
185 0efd7c9a 2022-07-30 op key=${1%%=*}
186 0efd7c9a 2022-07-30 op val=${1#*=}
187 0efd7c9a 2022-07-30 op
188 0efd7c9a 2022-07-30 op if [ "$key" = "--prefix" ]; then
189 0efd7c9a 2022-07-30 op key=PREFIX
190 0efd7c9a 2022-07-30 op if [ "$1" = "--prefix" ]; then
191 0efd7c9a 2022-07-30 op if ! shift 2>&1 >/dev/null; then
192 0efd7c9a 2022-07-30 op echo "$0: missing value for --prefix" 1>&2
193 0efd7c9a 2022-07-30 op exit 1
194 0efd7c9a 2022-07-30 op fi
195 0efd7c9a 2022-07-30 op val="$1"
196 0efd7c9a 2022-07-30 op fi
197 0efd7c9a 2022-07-30 op fi
198 0efd7c9a 2022-07-30 op
199 0efd7c9a 2022-07-30 op if [ "$1" = "$key" ]; then
200 0efd7c9a 2022-07-30 op echo "$0: invalid key-value: $1" 1>&2
201 0efd7c9a 2022-07-30 op exit 1
202 0efd7c9a 2022-07-30 op fi
203 0efd7c9a 2022-07-30 op
204 0efd7c9a 2022-07-30 op shift
205 0efd7c9a 2022-07-30 op
206 0efd7c9a 2022-07-30 op case "$key" in
207 0efd7c9a 2022-07-30 op LDADD)
208 0efd7c9a 2022-07-30 op LDADD="$val" ;;
209 0efd7c9a 2022-07-30 op LDADD_LIBEVENT)
210 0efd7c9a 2022-07-30 op LDADD_LIBEVENT="$val" ;;
211 0efd7c9a 2022-07-30 op LDADD_LIBEVENT2)
212 0efd7c9a 2022-07-30 op LDADD_LIBEVENT2="$val" ;;
213 0efd7c9a 2022-07-30 op LDADD_LIBSOCKET)
214 0efd7c9a 2022-07-30 op LDADD_LIBSOCKET="$val" ;;
215 0efd7c9a 2022-07-30 op LDFLAGS)
216 0efd7c9a 2022-07-30 op LDFLAGS="$val" ;;
217 0efd7c9a 2022-07-30 op CPPFLAGS)
218 0efd7c9a 2022-07-30 op CPPFLAGS="$val" ;;
219 0efd7c9a 2022-07-30 op DESTDIR)
220 0efd7c9a 2022-07-30 op DESTDIR="$val" ;;
221 0efd7c9a 2022-07-30 op PREFIX)
222 0efd7c9a 2022-07-30 op PREFIX="$val" ;;
223 0efd7c9a 2022-07-30 op MANDIR)
224 0efd7c9a 2022-07-30 op MANDIR="$val" ;;
225 0efd7c9a 2022-07-30 op LIBDIR)
226 0efd7c9a 2022-07-30 op LIBDIR="$val" ;;
227 0efd7c9a 2022-07-30 op BINDIR)
228 0efd7c9a 2022-07-30 op BINDIR="$val" ;;
229 0efd7c9a 2022-07-30 op SHAREDIR)
230 0efd7c9a 2022-07-30 op SHAREDIR="$val" ;;
231 0efd7c9a 2022-07-30 op SBINDIR)
232 0efd7c9a 2022-07-30 op SBINDIR="$val" ;;
233 0efd7c9a 2022-07-30 op INCLUDEDIR)
234 0efd7c9a 2022-07-30 op INCLUDEDIR="$val" ;;
235 0efd7c9a 2022-07-30 op PKG_CONFIG)
236 0efd7c9a 2022-07-30 op PKG_CONFIG="$val" ;;
237 0efd7c9a 2022-07-30 op *)
238 0efd7c9a 2022-07-30 op echo "$0: invalid key: $key" 1>&2
239 0efd7c9a 2022-07-30 op exit 1
240 0efd7c9a 2022-07-30 op esac
241 0efd7c9a 2022-07-30 op done
242 0efd7c9a 2022-07-30 op
243 0efd7c9a 2022-07-30 op
244 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
245 0efd7c9a 2022-07-30 op # These are the values that will be pushed into config.h after we test
246 0efd7c9a 2022-07-30 op # for whether they're supported or not.
247 0efd7c9a 2022-07-30 op # Each of these must have a runtest(), below.
248 0efd7c9a 2022-07-30 op # Please sort by alpha, for clarity.
249 0efd7c9a 2022-07-30 op # You WANT to change this.
250 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
251 0efd7c9a 2022-07-30 op
252 0efd7c9a 2022-07-30 op HAVE_GETEXECNAME=
253 0efd7c9a 2022-07-30 op HAVE_GETPROGNAME=
254 0efd7c9a 2022-07-30 op HAVE_LIBEVENT=
255 0efd7c9a 2022-07-30 op HAVE_LIBEVENT2=0 # may not be checked
256 0efd7c9a 2022-07-30 op HAVE_PLEDGE=
257 0efd7c9a 2022-07-30 op HAVE_PROGRAM_INVOCATION_SHORT_NAME=
258 0efd7c9a 2022-07-30 op HAVE_PR_SET_NAME=
259 0efd7c9a 2022-07-30 op HAVE_STRLCAT=
260 0efd7c9a 2022-07-30 op HAVE_STRLCPY=
261 0efd7c9a 2022-07-30 op HAVE_STRTONUM=
262 0efd7c9a 2022-07-30 op HAVE_UNVEIL=
263 0efd7c9a 2022-07-30 op HAVE___PROGNAME=
264 0efd7c9a 2022-07-30 op
265 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
266 0efd7c9a 2022-07-30 op # Allow configure.local to override all variables, default settings,
267 0efd7c9a 2022-07-30 op # command-line arguments, and tested features, above.
268 0efd7c9a 2022-07-30 op # You PROBABLY DO NOT want to change this.
269 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
270 0efd7c9a 2022-07-30 op
271 0efd7c9a 2022-07-30 op if [ -r ./configure.local ]; then
272 0efd7c9a 2022-07-30 op echo "configure.local: reading..." 1>&2
273 0efd7c9a 2022-07-30 op echo "configure.local: reading..." 1>&3
274 0efd7c9a 2022-07-30 op cat ./configure.local 1>&3
275 0efd7c9a 2022-07-30 op . ./configure.local
276 0efd7c9a 2022-07-30 op else
277 0efd7c9a 2022-07-30 op echo "configure.local: no (fully automatic configuration)" 1>&2
278 0efd7c9a 2022-07-30 op echo "configure.local: no (fully automatic configuration)" 1>&3
279 0efd7c9a 2022-07-30 op fi
280 0efd7c9a 2022-07-30 op
281 0efd7c9a 2022-07-30 op echo 1>&3
282 0efd7c9a 2022-07-30 op
283 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
284 0efd7c9a 2022-07-30 op # Infrastructure for running tests.
285 0efd7c9a 2022-07-30 op # These consists of a series of functions that will attempt to run the
286 0efd7c9a 2022-07-30 op # given test file and record its exit into a HAVE_xxx variable.
287 0efd7c9a 2022-07-30 op # You DO NOT want to change this.
288 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
289 0efd7c9a 2022-07-30 op
290 0efd7c9a 2022-07-30 op COMP="${CC} ${CFLAGS} ${CPPFLAGS} -Wno-unused -Werror"
291 0efd7c9a 2022-07-30 op
292 0efd7c9a 2022-07-30 op # Check whether this HAVE_ setting is manually overridden.
293 0efd7c9a 2022-07-30 op # If yes, use the override, if no, do not decide anything yet.
294 0efd7c9a 2022-07-30 op # Arguments: lower-case test name, manual value
295 0efd7c9a 2022-07-30 op
296 0efd7c9a 2022-07-30 op ismanual() {
297 0efd7c9a 2022-07-30 op [ -z "${3}" ] && return 1
298 0efd7c9a 2022-07-30 op echo "${1}: manual (HAVE_${2}=${3})" 1>&2
299 0efd7c9a 2022-07-30 op echo "${1}: manual (HAVE_${2}=${3})" 1>&3
300 0efd7c9a 2022-07-30 op echo 1>&3
301 0efd7c9a 2022-07-30 op return 0
302 0efd7c9a 2022-07-30 op }
303 0efd7c9a 2022-07-30 op
304 0efd7c9a 2022-07-30 op # Run a single autoconfiguration test.
305 0efd7c9a 2022-07-30 op # In case of success, enable the feature.
306 0efd7c9a 2022-07-30 op # In case of failure, do not decide anything yet.
307 0efd7c9a 2022-07-30 op # Arguments: lower-case test name, upper-case test name, additional
308 0efd7c9a 2022-07-30 op # CFLAGS, additional LIBS.
309 0efd7c9a 2022-07-30 op
310 0efd7c9a 2022-07-30 op singletest() {
311 0efd7c9a 2022-07-30 op extralib=""
312 0efd7c9a 2022-07-30 op pkgcfs=""
313 0efd7c9a 2022-07-30 op pkglib=""
314 0efd7c9a 2022-07-30 op
315 0efd7c9a 2022-07-30 op cat 1>&3 <<EOF
316 0efd7c9a 2022-07-30 op ${1}: testing...
317 0efd7c9a 2022-07-30 op ${COMP} -DTEST_${2} ${3} -o test-${1} tests.c ${LDFLAGS} ${4}
318 0efd7c9a 2022-07-30 op EOF
319 0efd7c9a 2022-07-30 op if ${COMP} -DTEST_${2} ${3} -o "test-${1}" tests.c ${LDFLAGS} ${4} 1>&3 2>&3; then
320 0efd7c9a 2022-07-30 op echo "${1}: ${CC} succeeded" 1>&3
321 0efd7c9a 2022-07-30 op else
322 0efd7c9a 2022-07-30 op if [ -n "${5}" ] ; then
323 0efd7c9a 2022-07-30 op echo "${1}: ${CC} failed with $? (retrying)" 1>&3
324 0efd7c9a 2022-07-30 op cat 1>&3 <<EOF
325 0efd7c9a 2022-07-30 op ${1}: testing...
326 0efd7c9a 2022-07-30 op ${COMP} -DTEST_${2} ${3} -o test-${1} tests.c ${LDFLAGS} ${5}
327 0efd7c9a 2022-07-30 op EOF
328 0efd7c9a 2022-07-30 op if ${COMP} -DTEST_${2} ${3} -o "test-${1}" tests.c ${LDFLAGS} ${5} 1>&3 2>&3; then
329 0efd7c9a 2022-07-30 op echo "${1}: ${CC} succeeded" 1>&3
330 0efd7c9a 2022-07-30 op extralib="(with ${5})"
331 0efd7c9a 2022-07-30 op else
332 0efd7c9a 2022-07-30 op test -n "${PKG_CONFIG}" -a -n "${6}" && ${PKG_CONFIG} "$6"
333 0efd7c9a 2022-07-30 op if [ $? -eq 0 ]; then
334 0efd7c9a 2022-07-30 op echo "${1}: ${CC} failed with $? (retrying)" 1>&3
335 0efd7c9a 2022-07-30 op pkgcfs=$($PKG_CONFIG --cflags "${6}")
336 0efd7c9a 2022-07-30 op pkglib=$($PKG_CONFIG --libs "${6}")
337 0efd7c9a 2022-07-30 op cat 1>&3 <<EOF
338 0efd7c9a 2022-07-30 op ${1}: testing...
339 0efd7c9a 2022-07-30 op ${COMP} -DTEST_${2} ${3} ${pkgcfs} -o test-${1} tests.c ${LDFLAGS} ${pkglib}
340 0efd7c9a 2022-07-30 op EOF
341 0efd7c9a 2022-07-30 op if ${COMP} -DTEST_${2} ${3} ${pkgcfs} -o test-${1} tests.c ${LDFLAGS} ${pkglib} 1>&3 2>&3; then
342 0efd7c9a 2022-07-30 op echo "${1}: ${CC} succeeded" 1>&3
343 0efd7c9a 2022-07-30 op extralib="(with ${pkgcfs} ${pkglib})"
344 0efd7c9a 2022-07-30 op else
345 0efd7c9a 2022-07-30 op echo "${1}: ${CC} failed with $?" 1>&3
346 0efd7c9a 2022-07-30 op echo 1>&3
347 0efd7c9a 2022-07-30 op return 1
348 0efd7c9a 2022-07-30 op fi
349 0efd7c9a 2022-07-30 op else
350 0efd7c9a 2022-07-30 op echo "${1}: ${CC} failed with $?" 1>&3
351 0efd7c9a 2022-07-30 op echo 1>&3
352 0efd7c9a 2022-07-30 op return 1
353 0efd7c9a 2022-07-30 op fi
354 0efd7c9a 2022-07-30 op fi
355 0efd7c9a 2022-07-30 op else
356 0efd7c9a 2022-07-30 op echo "${1}: ${CC} failed with $?" 1>&3
357 0efd7c9a 2022-07-30 op echo 1>&3
358 0efd7c9a 2022-07-30 op return 1
359 0efd7c9a 2022-07-30 op fi
360 0efd7c9a 2022-07-30 op fi
361 0efd7c9a 2022-07-30 op
362 0efd7c9a 2022-07-30 op rm -f test-${1}.d
363 0efd7c9a 2022-07-30 op
364 0efd7c9a 2022-07-30 op if [ -n "${pkgcfs}" -o -n "${pkglib}" ]
365 0efd7c9a 2022-07-30 op then
366 0efd7c9a 2022-07-30 op CFLAGS="${CFLAGS} ${pkgcfs}"
367 0efd7c9a 2022-07-30 op eval "LDADD_${2}=\"${pkglib}\""
368 0efd7c9a 2022-07-30 op elif [ -n "${extralib}" ]
369 0efd7c9a 2022-07-30 op then
370 0efd7c9a 2022-07-30 op eval "LDADD_${2}=\"${5}\""
371 0efd7c9a 2022-07-30 op elif [ -n "${4}" ]
372 0efd7c9a 2022-07-30 op then
373 0efd7c9a 2022-07-30 op eval "LDADD_${2}=\"${4}\""
374 0efd7c9a 2022-07-30 op fi
375 0efd7c9a 2022-07-30 op
376 0efd7c9a 2022-07-30 op echo "${1}: yes ${extralib}" 1>&2
377 0efd7c9a 2022-07-30 op echo "${1}: yes ${extralib}" 1>&3
378 0efd7c9a 2022-07-30 op echo 1>&3
379 0efd7c9a 2022-07-30 op eval HAVE_${2}=1
380 0efd7c9a 2022-07-30 op rm "test-${1}"
381 0efd7c9a 2022-07-30 op return 0
382 0efd7c9a 2022-07-30 op }
383 0efd7c9a 2022-07-30 op
384 0efd7c9a 2022-07-30 op # Run a complete autoconfiguration test, including the check for
385 0efd7c9a 2022-07-30 op # a manual override and disabling the feature on failure.
386 0efd7c9a 2022-07-30 op # Arguments: lower case name, upper case name, additional CFLAGS,
387 0efd7c9a 2022-07-30 op # additional LDADD, alternative LDADD, pkg-config name.
388 0efd7c9a 2022-07-30 op
389 0efd7c9a 2022-07-30 op runtest() {
390 0efd7c9a 2022-07-30 op eval _manual=\${HAVE_${2}}
391 0efd7c9a 2022-07-30 op ismanual "${1}" "${2}" "${_manual}" && return 0
392 0efd7c9a 2022-07-30 op singletest "${1}" "${2}" "${3}" "${4}" "${5}" "${6}" && return 0
393 0efd7c9a 2022-07-30 op echo "${1}: no" 1>&2
394 0efd7c9a 2022-07-30 op eval HAVE_${2}=0
395 0efd7c9a 2022-07-30 op return 1
396 0efd7c9a 2022-07-30 op }
397 0efd7c9a 2022-07-30 op
398 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
399 0efd7c9a 2022-07-30 op # Begin running the tests themselves.
400 0efd7c9a 2022-07-30 op # All of your tests must be defined here.
401 0efd7c9a 2022-07-30 op # Please sort as the HAVE_xxxx values were defined.
402 0efd7c9a 2022-07-30 op # You WANT to change this.
403 0efd7c9a 2022-07-30 op # It consists of the following columns:
404 0efd7c9a 2022-07-30 op # runtest
405 0efd7c9a 2022-07-30 op # (1) test file
406 0efd7c9a 2022-07-30 op # (2) macro to set
407 0efd7c9a 2022-07-30 op # (3) argument to cc *before* -o
408 0efd7c9a 2022-07-30 op # (4) argument to cc *after*
409 0efd7c9a 2022-07-30 op # (5) alternative argument to cc *after*
410 0efd7c9a 2022-07-30 op # (6) name for pkg-config auto-discovery
411 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
412 0efd7c9a 2022-07-30 op
413 0efd7c9a 2022-07-30 op if runtest -MMD _MMD -MMD; then
414 0efd7c9a 2022-07-30 op CFLAGS="${CFLAGS} -MMD"
415 0efd7c9a 2022-07-30 op echo "adding -MMD to CFLAGS" 1>&2
416 0efd7c9a 2022-07-30 op echo "adding -MMD to CFLAGS" 1>&3
417 0efd7c9a 2022-07-30 op fi
418 0efd7c9a 2022-07-30 op
419 0efd7c9a 2022-07-30 op runtest getexecname GETEXECNAME || true
420 0efd7c9a 2022-07-30 op runtest getprogname GETPROGNAME || true
421 0efd7c9a 2022-07-30 op
422 0efd7c9a 2022-07-30 op runtest libevent LIBEVENT "" "" "-levent" || \
423 0efd7c9a 2022-07-30 op runtest libevent2 LIBEVENT2 "" "" "-levent_extra -levent_core" "libevent" || true
424 0efd7c9a 2022-07-30 op
425 0efd7c9a 2022-07-30 op runtest lib_socket LIB_SOCKET "" "" "-lsocket -lnsl" || true
426 0efd7c9a 2022-07-30 op runtest pledge PLEDGE || true
427 0efd7c9a 2022-07-30 op runtest program_invocation_short_name PROGRAM_INVOCATION_SHORT_NAME || true
428 0efd7c9a 2022-07-30 op runtest PR_SET_NAME PR_SET_NAME || true
429 0efd7c9a 2022-07-30 op runtest static STATIC "" "-static" || true
430 0efd7c9a 2022-07-30 op runtest strlcat STRLCAT || true
431 0efd7c9a 2022-07-30 op runtest strlcpy STRLCPY || true
432 0efd7c9a 2022-07-30 op runtest strtonum STRTONUM || true
433 0efd7c9a 2022-07-30 op runtest unveil UNVEIL || true
434 0efd7c9a 2022-07-30 op runtest __progname __PROGNAME || true
435 0efd7c9a 2022-07-30 op
436 0efd7c9a 2022-07-30 op if [ "${HAVE_LIBEVENT}" -eq 0 -a "${HAVE_LIBEVENT2}" -eq 0 ]; then
437 0efd7c9a 2022-07-30 op echo "Fatal: missing libevent" 1>&2
438 0efd7c9a 2022-07-30 op echo "Fatal: missing libevent" 1>&3
439 0efd7c9a 2022-07-30 op exit 1
440 0efd7c9a 2022-07-30 op fi
441 0efd7c9a 2022-07-30 op
442 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
443 0efd7c9a 2022-07-30 op # Output writing: generate the config.h file.
444 0efd7c9a 2022-07-30 op # This file contains all of the HAVE_xxxx variables necessary for
445 0efd7c9a 2022-07-30 op # compiling your source.
446 0efd7c9a 2022-07-30 op # You must include "config.h" BEFORE any other variables.
447 0efd7c9a 2022-07-30 op # You WANT to change this.
448 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
449 0efd7c9a 2022-07-30 op
450 0efd7c9a 2022-07-30 op exec > config.h
451 0efd7c9a 2022-07-30 op
452 0efd7c9a 2022-07-30 op # Start with prologue.
453 0efd7c9a 2022-07-30 op
454 0efd7c9a 2022-07-30 op cat <<EOF
455 0efd7c9a 2022-07-30 op #ifndef OCONFIGURE_CONFIG_H
456 0efd7c9a 2022-07-30 op #define OCONFIGURE_CONFIG_H
457 0efd7c9a 2022-07-30 op
458 0efd7c9a 2022-07-30 op #ifdef __cplusplus
459 0efd7c9a 2022-07-30 op # error "Do not use C++: this is a C application."
460 0efd7c9a 2022-07-30 op #endif
461 0efd7c9a 2022-07-30 op #if !defined(__GNUC__) || (__GNUC__ < 4)
462 0efd7c9a 2022-07-30 op # define __attribute__(x)
463 0efd7c9a 2022-07-30 op #endif
464 0efd7c9a 2022-07-30 op #if defined(__linux__) || defined(__MINT__)
465 0efd7c9a 2022-07-30 op # define _GNU_SOURCE /* memmem, memrchr, setresuid... */
466 0efd7c9a 2022-07-30 op # define _DEFAULT_SOURCE /* le32toh, crypt, ... */
467 0efd7c9a 2022-07-30 op #endif
468 0efd7c9a 2022-07-30 op #if defined(__NetBSD__)
469 0efd7c9a 2022-07-30 op # define _OPENBSD_SOURCE /* reallocarray, etc. */
470 0efd7c9a 2022-07-30 op #endif
471 0efd7c9a 2022-07-30 op #if defined(__sun)
472 0efd7c9a 2022-07-30 op # ifndef _XOPEN_SOURCE /* SunOS already defines */
473 0efd7c9a 2022-07-30 op # define _XOPEN_SOURCE /* XPGx */
474 0efd7c9a 2022-07-30 op # endif
475 0efd7c9a 2022-07-30 op # define _XOPEN_SOURCE_EXTENDED 1 /* XPG4v2 */
476 0efd7c9a 2022-07-30 op # ifndef __EXTENSIONS__ /* SunOS already defines */
477 0efd7c9a 2022-07-30 op # define __EXTENSIONS__ /* reallocarray, etc. */
478 0efd7c9a 2022-07-30 op # endif
479 0efd7c9a 2022-07-30 op #endif
480 0efd7c9a 2022-07-30 op #if !defined(__BEGIN_DECLS)
481 0efd7c9a 2022-07-30 op # define __BEGIN_DECLS
482 0efd7c9a 2022-07-30 op #endif
483 0efd7c9a 2022-07-30 op #if !defined(__END_DECLS)
484 0efd7c9a 2022-07-30 op # define __END_DECLS
485 0efd7c9a 2022-07-30 op #endif
486 0efd7c9a 2022-07-30 op
487 0efd7c9a 2022-07-30 op EOF
488 0efd7c9a 2022-07-30 op
489 0efd7c9a 2022-07-30 op # This is just for size_t, mode_t, and dev_t.
490 0efd7c9a 2022-07-30 op # Most of these functions, in the real world, pull in <string.h> or
491 0efd7c9a 2022-07-30 op # someting that pulls in support for size_t.
492 0efd7c9a 2022-07-30 op # Our function declarations are standalone, so specify them here.
493 0efd7c9a 2022-07-30 op
494 0efd7c9a 2022-07-30 op if [ ${HAVE_STRLCAT} -eq 0 -o \
495 0efd7c9a 2022-07-30 op ${HAVE_STRLCPY} -eq 0 ]
496 0efd7c9a 2022-07-30 op then
497 0efd7c9a 2022-07-30 op echo "#include <sys/types.h> /* size_t, mode_t, dev_t */ "
498 0efd7c9a 2022-07-30 op echo
499 0efd7c9a 2022-07-30 op fi
500 0efd7c9a 2022-07-30 op
501 0efd7c9a 2022-07-30 op if [ ${HAVE_GETPROGNAME} -eq 0 ]; then
502 0efd7c9a 2022-07-30 op echo "#include <stdlib.h>"
503 0efd7c9a 2022-07-30 op echo
504 0efd7c9a 2022-07-30 op fi
505 0efd7c9a 2022-07-30 op
506 0efd7c9a 2022-07-30 op if [ ${HAVE_PLEDGE} -eq 0 -o ${HAVE_UNVEIL} -eq 0 ]; then
507 0efd7c9a 2022-07-30 op echo "#include <unistd.h>"
508 0efd7c9a 2022-07-30 op echo
509 0efd7c9a 2022-07-30 op fi
510 0efd7c9a 2022-07-30 op
511 0efd7c9a 2022-07-30 op if [ ${HAVE_LIBEVENT2} -eq 1 ]; then
512 0efd7c9a 2022-07-30 op cat <<EOF
513 0efd7c9a 2022-07-30 op #include <event2/event.h>
514 0efd7c9a 2022-07-30 op #include <event2/event_compat.h>
515 0efd7c9a 2022-07-30 op #include <event2/event_struct.h>
516 0efd7c9a 2022-07-30 op #include <event2/buffer.h>
517 0efd7c9a 2022-07-30 op #include <event2/buffer_compat.h>
518 0efd7c9a 2022-07-30 op #include <event2/bufferevent.h>
519 0efd7c9a 2022-07-30 op #include <event2/bufferevent_struct.h>
520 0efd7c9a 2022-07-30 op #include <event2/bufferevent_compat.h>
521 0efd7c9a 2022-07-30 op EOF
522 0efd7c9a 2022-07-30 op fi
523 0efd7c9a 2022-07-30 op
524 0efd7c9a 2022-07-30 op if [ ${HAVE_LIBEVENT} -eq 1 ]; then
525 0efd7c9a 2022-07-30 op cat <<EOF
526 0efd7c9a 2022-07-30 op #include <event.h>
527 0efd7c9a 2022-07-30 op EOF
528 0efd7c9a 2022-07-30 op fi
529 0efd7c9a 2022-07-30 op
530 0efd7c9a 2022-07-30 op # Now we handle our HAVE_xxxx values.
531 0efd7c9a 2022-07-30 op # Most will just be defined as 0 or 1.
532 0efd7c9a 2022-07-30 op
533 0efd7c9a 2022-07-30 op cat <<EOF
534 0efd7c9a 2022-07-30 op
535 0efd7c9a 2022-07-30 op /*
536 0efd7c9a 2022-07-30 op * Results of configuration feature-testing.
537 0efd7c9a 2022-07-30 op */
538 0efd7c9a 2022-07-30 op #define HAVE_GETEXECNAME ${HAVE_GETEXECNAME}
539 0efd7c9a 2022-07-30 op #define HAVE_GETPROGNAME ${HAVE_GETPROGNAME}
540 0efd7c9a 2022-07-30 op #define HAVE_PLEDGE ${HAVE_PLEDGE}
541 0efd7c9a 2022-07-30 op #define HAVE_PROGRAM_INVOCATION_SHORT_NAME ${HAVE_PROGRAM_INVOCATION_SHORT_NAME}
542 0efd7c9a 2022-07-30 op #define HAVE_PR_SET_NAME ${HAVE_PR_SET_NAME}
543 0efd7c9a 2022-07-30 op #define HAVE_STRLCAT ${HAVE_STRLCAT}
544 0efd7c9a 2022-07-30 op #define HAVE_STRLCPY ${HAVE_STRLCPY}
545 0efd7c9a 2022-07-30 op #define HAVE_STRTONUM ${HAVE_STRTONUM}
546 0efd7c9a 2022-07-30 op #define HAVE_UNVEIL ${HAVE_UNVEIL}
547 0efd7c9a 2022-07-30 op #define HAVE___PROGNAME ${HAVE___PROGNAME}
548 0efd7c9a 2022-07-30 op
549 0efd7c9a 2022-07-30 op /* Now we do our function declarations for missing functions. */
550 0efd7c9a 2022-07-30 op
551 0efd7c9a 2022-07-30 op #if !HAVE_GETPROGNAME
552 0efd7c9a 2022-07-30 op extern const char *getprogname(void);
553 0efd7c9a 2022-07-30 op #endif
554 0efd7c9a 2022-07-30 op
555 0efd7c9a 2022-07-30 op #if !HAVE_STRLCAT
556 0efd7c9a 2022-07-30 op extern size_t strlcat(char *, const char *, size_t);
557 0efd7c9a 2022-07-30 op #endif
558 0efd7c9a 2022-07-30 op
559 0efd7c9a 2022-07-30 op #if !HAVE_STRLCPY
560 0efd7c9a 2022-07-30 op extern size_t strlcpy(char *, const char *, size_t);
561 0efd7c9a 2022-07-30 op #endif
562 0efd7c9a 2022-07-30 op
563 0efd7c9a 2022-07-30 op #if !HAVE_STRTONUM
564 0efd7c9a 2022-07-30 op extern long long strtonum(const char *, long long, long long, const char **);
565 0efd7c9a 2022-07-30 op #endif
566 0efd7c9a 2022-07-30 op
567 0efd7c9a 2022-07-30 op #ifndef __dead
568 0efd7c9a 2022-07-30 op # define __dead __attribute__((noreturn))
569 0efd7c9a 2022-07-30 op #endif
570 0efd7c9a 2022-07-30 op
571 0efd7c9a 2022-07-30 op #endif /*!OCONFIGURE_CONFIG_H*/
572 0efd7c9a 2022-07-30 op EOF
573 0efd7c9a 2022-07-30 op
574 0efd7c9a 2022-07-30 op echo "config.h: written" 1>&2
575 0efd7c9a 2022-07-30 op echo "config.h: written" 1>&3
576 0efd7c9a 2022-07-30 op
577 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
578 0efd7c9a 2022-07-30 op # Now we go to generate our Makefile.configure.
579 0efd7c9a 2022-07-30 op # This file is simply a bunch of Makefile variables.
580 0efd7c9a 2022-07-30 op # They'll work in both GNUmakefile and BSDmakefile.
581 0efd7c9a 2022-07-30 op # You MIGHT want to change this.
582 0efd7c9a 2022-07-30 op #----------------------------------------------------------------------
583 0efd7c9a 2022-07-30 op
584 0efd7c9a 2022-07-30 op exec > Makefile.configure
585 0efd7c9a 2022-07-30 op
586 0efd7c9a 2022-07-30 op [ -z "${BINDIR}" ] && BINDIR="${PREFIX}/bin"
587 0efd7c9a 2022-07-30 op [ -z "${SBINDIR}" ] && SBINDIR="${PREFIX}/sbin"
588 0efd7c9a 2022-07-30 op [ -z "${INCLUDEDIR}" ] && INCLUDEDIR="${PREFIX}/include"
589 0efd7c9a 2022-07-30 op [ -z "${LIBDIR}" ] && LIBDIR="${PREFIX}/lib"
590 0efd7c9a 2022-07-30 op [ -z "${MANDIR}" ] && MANDIR="${PREFIX}/man"
591 0efd7c9a 2022-07-30 op [ -z "${SHAREDIR}" ] && SHAREDIR="${PREFIX}/share"
592 0efd7c9a 2022-07-30 op
593 0efd7c9a 2022-07-30 op [ -z "${INSTALL_PROGRAM}" ] && INSTALL_PROGRAM="${INSTALL} -m 0555"
594 0efd7c9a 2022-07-30 op [ -z "${INSTALL_LIB}" ] && INSTALL_LIB="${INSTALL} -m 0444"
595 0efd7c9a 2022-07-30 op [ -z "${INSTALL_MAN}" ] && INSTALL_MAN="${INSTALL} -m 0444"
596 0efd7c9a 2022-07-30 op [ -z "${INSTALL_DATA}" ] && INSTALL_DATA="${INSTALL} -m 0444"
597 0efd7c9a 2022-07-30 op
598 0efd7c9a 2022-07-30 op cat <<EOF
599 0efd7c9a 2022-07-30 op CC = ${CC}
600 0efd7c9a 2022-07-30 op CFLAGS = ${CFLAGS}
601 0efd7c9a 2022-07-30 op CPPFLAGS = ${CPPFLAGS}
602 0efd7c9a 2022-07-30 op LDADD = ${LDADD} ${LDADD_LIB_SOCKET} ${LDADD_LIBEVENT} ${LDADD_LIBEVENT2}
603 0efd7c9a 2022-07-30 op LDADD_STATIC = ${LDADD_STATIC}
604 0efd7c9a 2022-07-30 op LDFLAGS = ${LDFLAGS}
605 0efd7c9a 2022-07-30 op PREFIX = ${PREFIX}
606 0efd7c9a 2022-07-30 op BINDIR = ${BINDIR}
607 0efd7c9a 2022-07-30 op SHAREDIR = ${SHAREDIR}
608 0efd7c9a 2022-07-30 op SBINDIR = ${SBINDIR}
609 0efd7c9a 2022-07-30 op INCLUDEDIR = ${INCLUDEDIR}
610 0efd7c9a 2022-07-30 op LIBDIR = ${LIBDIR}
611 0efd7c9a 2022-07-30 op MANDIR = ${MANDIR}
612 0efd7c9a 2022-07-30 op INSTALL = ${INSTALL}
613 0efd7c9a 2022-07-30 op INSTALL_PROGRAM = ${INSTALL_PROGRAM}
614 0efd7c9a 2022-07-30 op INSTALL_LIB = ${INSTALL_LIB}
615 0efd7c9a 2022-07-30 op INSTALL_MAN = ${INSTALL_MAN}
616 0efd7c9a 2022-07-30 op INSTALL_DATA = ${INSTALL_DATA}
617 0efd7c9a 2022-07-30 op EOF
618 0efd7c9a 2022-07-30 op
619 0efd7c9a 2022-07-30 op echo "Makefile.configure: written" 1>&2
620 0efd7c9a 2022-07-30 op echo "Makefile.configure: written" 1>&3
621 0efd7c9a 2022-07-30 op
622 0efd7c9a 2022-07-30 op exit 0